{% extends "polybookexchange/base.html" %}
{% load i18n static %}

{% block title %}{{block.super}} :: {% trans "Privilege administration" %}{% endblock %}

{% block content %}
    <!-- select2 4.0.13 -->
    <link href="{% static 'app/select2/css/select2.min.css' %}" rel="stylesheet" />
    <script src="{% static 'app/select2/js/select2.full.min.js' %}"></script>

    <!-- SweetAlert2 11.7.1 -->
    <link href="{% static 'app/sweetalert2/sweetalert2.min.css' %}" rel="stylesheet" />
    <script src="{% static 'app/sweetalert2/sweetalert2.min.js' %}"></script>


    <h1>{% trans "Privilege administration" %}</h1>
    <hr />

    <p>
        {% trans "Administrators can access the administration pages except this one. Superadmins can do anything" %}
    </p>

    <h2>{% trans "Administrators" %}</h2>

    <table class="table table-bordered table-striped table-hover">
        <thead>
            <tr>
                <th>{% trans "SCIPER" %}</th>
                <th>{% trans "First name" %}</th>
                <th>{% trans "Last name" %}</th>
                <th></th>
            </tr>
        </thead>
        <tbody>
            {% for admin in staff_members %}
                <tr>
                    <td>{{admin.username}}</td>
                    <td>{{admin.first_name}}</td>
                    <td>{{admin.last_name}}</td>
                    <td>
                        <button type="button" class="btn btn-sm btn-success" onclick="promote({{admin.username}})">
                            <i class="fas fa-circle-up"></i> {% trans "Promote to superadmin" %}
                        </button>
                        <button type="button" class="btn btn-sm btn-danger" onclick="remove({{admin.username}})">
                            <i class="fas fa-trash"></i> {% trans "Remove" %}
                        </button>
                    </td>
                </tr>
            {% endfor %}

            <tr>
                <td colspan="3">
                    <form id="add-admin-form" method="POST">
                        {% csrf_token %}
                        <input type="hidden" name="action" value="add_admin" />
                        <select id="add-admin" class="form-select" name="scipers" multiple></select>
                    </form>
                </td>
                <td>
                    <button type="button" class="btn btn-sm btn-success" onclick="add_admin()">
                        <i class="fas fa-plus"></i> {% trans "Add" %}
                    </button>
                </td>
            </tr>
        </tbody>
    </table>

    <h2>{% trans "Superadmins" %}</h2>

    <table class="table table-bordered table-striped table-hover">
        <thead>
            <tr>
                <th>{% trans "SCIPER" %}</th>
                <th>{% trans "First name" %}</th>
                <th>{% trans "Last name" %}</th>
                <th></th>
            </tr>
        </thead>
        <tbody>
            {% for admin in superusers %}
                <tr>
                    <td>{{admin.username}}</td>
                    <td>{{admin.first_name}}</td>
                    <td>{{admin.last_name}}</td>
                    <td>
                        <button type="button" class="btn btn-sm btn-warning" onclick="demote({{admin.username}})">
                            <i class="fas fa-circle-down"></i> {% trans "Demote to administrator" %}
                        </button>
                        <button type="button" class="btn btn-sm btn-danger" onclick="remove({{admin.username}})">
                            <i class="fas fa-trash"></i> {% trans "Remove" %}
                        </button>
                    </td>
                </tr>
            {% endfor %}

            <tr>
                <td colspan="3">
                    <form id="add-superadmin-form" method="POST">
                        {% csrf_token %}
                        <input type="hidden" name="action" value="add_superadmin" />
                        <select id="add-superadmin" class="form-select" name="scipers" multiple></select>
                    </form>
                </td>
                <td>
                    <button type="button" class="btn btn-sm btn-success" onclick="add_superadmin()">
                        <i class="fas fa-plus"></i> {% trans "Add" %}
                    </button>
                </td>
            </tr>
        </tbody>

    </table>

    <form id="action-form" class="d-none" method="POST">
        {% csrf_token %}
        <input id="action" type="hidden" name="action" value="" />
        <input id="sciper" type="hidden" name="sciper" value="" />
    </form>

    <script type="text/javascript">
        function action(type, sciper, message) {
            Swal.fire({
                title: '{{ _("Are you sure?") | escapejs }}',
                text: message,
                icon: 'warning',
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                confirmButtonText: '{{ _("Yes") | escapejs }}',
                cancelButtonText: '{{ _("Cancel") | escapejs }}',
            }).then((result) => {
                if (result.isConfirmed) {
                    $("#action").val(type);
                    $("#sciper").val(sciper);
                    $("#action-form").submit();
                }
            });
        }

        function promote(sciper) {
            action("promote", sciper, `{{ _("Promote user ${sciper} to superadmin?") | escapejs }}`);
        }

        function demote(sciper) {
            action("demote", sciper, `{{ _("Demote user ${sciper} from superadmin to administrator?") | escapejs }}`);
        }

        function remove(sciper) {
            action("remove", sciper, `{{ _("Remove the administrator status of user ${sciper}?") | escapejs }}`);
        }

        function add_admin() {
            Swal.fire({
                title: '{{ _("Are you sure?") | escapejs }}',
                text: '{{ _("Promote the selected users to administrator?") | escapejs }}',
                icon: 'warning',
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                confirmButtonText: '{{ _("Yes") | escapejs }}',
                cancelButtonText: '{{ _("Cancel") | escapejs }}',
            }).then((result) => {
                $("#add-admin-form").submit();
            });
        }

        function add_superadmin() {
            Swal.fire({
                title: '{{ _("Are you sure?") | escapejs }}',
                text: '{{ _("Promote the selected users to superadmin?") | escapejs }}',
                icon: 'warning',
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                confirmButtonText: '{{ _("Yes") | escapejs }}',
                cancelButtonText: '{{ _("Cancel") | escapejs }}',
            }).then((result) => {
                $("#add-superadmin-form").submit();
            });
        }

        $("#add-admin").select2({
            ajax: {
                url: "{% url 'add_admin_autocomplete' %}",
                dataType: "json",
            },
            minimumInputLength: 1,
        });

        $("#add-superadmin").select2({
            ajax: {
                url: "{% url 'add_superadmin_autocomplete' %}",
                dataType: "json",
            },
            minimumInputLength: 1,
        });

        $('#polybook-menu-admin').addClass('active');
    </script>

{% endblock %}
